<?php
/*
Plugin Name: XHTML Video Embed
Plugin URI: http://saltwaterc.net/xhtml-video-embed
Description: XVE is a WordPress plug-in which embeds the videos in the right way, the XHTML way. The plug-in is self documented, so please check <a href="options-general.php?page=xhtml-video-embed.php">Options &raquo; XVE</a> for configuration details and usage information.
Version: 0.2.3
Author: SaltwaterC
Author URI: http://saltwaterc.net/
License: GPL v2.0
*/

function swc_flash_object($_fileType)
	{
	switch ($_fileType)
		{
		default:
		$_objH=get_option("swc_vflash_height");
		break;
		
		case "audio":
		$_objH=get_option("swc_aflash_height");
		break;
		}
	$_objW=get_option("swc_flash_width");
	
	$_displayCredit=(get_option("swc_display_credit")=="no")?"<!-- Valid XHTML ".$_fileType." object delivered by XHTML Video Embed. Get it at: http://saltwaterc.net/xhtml-video-embed -->":"<small><a href='http://saltwaterc.net/xhtml-video-embed' target='_blank' title='XHTML Video Embed - Delivers valid XHTML flash content into your WordPress blog'>&raquo; Powered by XHTML Video Embed</a></small>";
	
	$_flashObject=<<<FLASH

<object type="application/x-shockwave-flash" style="width: {$_objW}px; height: {$_objH}px;" data="&*DATA*&">
<param name="quality" value="best" />
<param name="wmode" value="transparent" />
<param name="movie" value="&*DATA*&" />
<param name="plug-inspage" value="http://www.macromedia.com/go/getflashplayer" />
</object>
<br/>
{$_displayCredit}

FLASH;
	
	return $_flashObject;
	}
	
function swc_convert_url($_iURL, $_fileType, $_supportedService)
	{
	switch ($_supportedService)
		{
		case "swf":
		return $_iURL;
		break;
		
		case "youtube":
		preg_match("@v=(.*)@i", $_iURL, $_theMatch);
		$_theMatch=preg_replace("@&.*@i", "", $_theMatch[1]);
		return "http://www.youtube.com/v/".preg_replace("@[^a-zA-Z0-9]@", "", $_theMatch);
		break;
		
		case "google-video":
		preg_match("@docid=(.*)@i", $_iURL, $_theMatch);
		$_theMatch=preg_replace("@&.*@i", "", $_theMatch[1]);
		return "http://video.google.com/googleplayer.swf?docId=".preg_replace("@[^0-9\-]@", "", $_theMatch)."&amp;hl=en";
		break;
		
		case "metacafe":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.metacafe.com/fplayer/".preg_replace("@[^0-9]@", "", $_smallPieces[4])."/".preg_replace("@[^a-zA-Z0-9\_]@", "", $_smallPieces[5]).".swf";
		break;
		
		case "trilu-video":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".preg_replace("@[^a-zA-Z0-9]@", "",$_smallPieces[4])."&amp;userid=".preg_replace("@[^a-zA-Z0-9\_]@", "", $_smallPieces[3]);
		break;
		
		case "trilu-audio":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".preg_replace("@[^a-zA-Z0-9]@", "",$_smallPieces[4])."&amp;userid=".preg_replace("@[^a-zA-Z\_]@", "", $_smallPieces[3]);
		break;
		
		case "trilu-imagine":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".preg_replace("@[^a-zA-Z0-9]@", "",$_smallPieces[4])."&amp;userid=".preg_replace("@[^a-zA-Z\_]@", "", $_smallPieces[3]);
		break;
		
		case "trilu-image":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".preg_replace("@[^a-zA-Z0-9]@", "",$_smallPieces[4])."&amp;userid=".preg_replace("@[^a-zA-Z\_]@", "", $_smallPieces[3]);
		break;
		
		case "dailymotion":
		$_smallPieces=explode("/", $_iURL);
		$_theKey=preg_grep("@^video$@i", $_smallPieces);
		$_theKey=array_keys($_theKey);
		$_theKey=$_theKey[0];
		$_smallPieces=explode("_", $_smallPieces[$_theKey+1]);
		return "http://www.dailymotion.com/swf/".preg_replace("@[^a-zA-Z0-9]@", "", $_smallPieces[0])."&amp;v3=1&amp;related=0";
		break;
		
		case "myspace":
		preg_match("@VideoID=(\d+)@i", $_iURL, $_theMatch);
		return "http://lads.myspace.com/videos/vplayer.swf?m=".$_theMatch[1]."&amp;v=2&amp;type=video";
		break;
		
		case "revver":
		$_smallPieces=explode("/", $_iURL);
		$_theKey=preg_grep("@^video$@i", $_smallPieces);
		$_theKey=array_keys($_theKey);
		$_theKey=$_theKey[0];
		return "http://flash.revver.com/player/1.0/player.swf?mediaId=".preg_replace("@[^0-9]@", "",$_smallPieces[$_theKey+1]);
		break;
		
		case "spike":
		$_smallPieces=explode("/", $_iURL);
		$_theKey=preg_grep("@^video$@i", $_smallPieces);
		$_theKey=array_keys($_theKey);
		$_theKey=$_theKey[0];
		$_smallPieces=explode("?", $_smallPieces[$_theKey+1]);
		return "http://www.spike.com/efp?flvbaseclip=".preg_replace("@[^0-9]@", "",$_smallPieces[0]);
		break;
		
		case "vimeo":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.vimeo.com/moogaloop.swf?clip_id=".preg_replace("@[^0-9]@", "", $_smallPieces[3])."&amp;server=www.vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0";
		break;
		
		default:
		return "CODING ERROR!!!";
		break;
		}
	}

function swc_content_filter($_theContent='', $_fileType, $_supportedService)
	{
	$n=preg_match_all("@\[".$_supportedService."\](.*)\[/".$_supportedService."\]@i", $_theContent, $_theMatches);
	$i=0;
	while ($i<$n)
		{
		$_theContent=str_replace($_theMatches[0][$i], str_replace("&*DATA*&", swc_convert_url($_theMatches[1][$i], $_fileType, $_supportedService), swc_flash_object($_fileType)), $_theContent);
		$i++;
		}
	return $_theContent;
	}

function swc_xhtml_video_embed($_theContent='')
	{
	// Making sure that the default options are defined
	swc_add_options();
	
	//The call to the functuion which does all the conversion should be something like: $_theContent=swc_content_filter($_theContent, $_fileType, $_supportedService); - where the $_fileType is video, audio or image, and $_supported service must be defined into the swc_convert_url()'s switch
	// This IS the main function who does all the magic, but it's powered by the other small pieces which provide the required functionality
	
	// Generic SWF support:
	if (get_option("swc_swf_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "swf");
	// YouTube support:
	if (get_option("swc_youtube_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "youtube");
	// Google Video support:
	if (get_option("swc_google_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "google-video");
	// Metacafe support:
	if (get_option("swc_metacafe_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "metacafe");
	// Trilulilu Video support:
	if (get_option("swc_trilu_video_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "trilu-video");
	// Trilulilu Audio support:
	if (get_option("swc_trilu_audio_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "audio", "trilu-audio");
	// Trilulilu Image support:
	if (get_option("swc_trilu_image_support")=="yes")
		{
		$_theContent=swc_content_filter($_theContent, "image", "trilu-imagine");
		$_theContent=swc_content_filter($_theContent, "image", "trilu-image");
		}
	// Dailymotion Video support:
	if (get_option("swc_daily_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "dailymotion");
	// MySpace TV Video support:
	if (get_option("swc_myspace_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "myspace");
	// Revver Video support:
	if (get_option("swc_revver_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "revver");
	// Spike Video support:
	if (get_option("swc_spike_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "spike");
	// Vimeo Video support:
	if (get_option("swc_vimeo_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "vimeo");
	return $_theContent;
	}
	
function swc_xhtml_video_admin()
	{
	if (function_exists('add_options_page'))
		{
		add_options_page('xhtml-video-embed', 'XVE', 1, basename(__FILE__), 'swc_xhtml_video_admin_panel');
		}
	}
	
function swc_add_options()
	{
	// Add some options at the first usage
	
	// Service support:
	add_option("swc_swf_support", "yes");
	add_option("swc_trilu_video_support", "yes");
	add_option("swc_trilu_audio_support", "yes");
	add_option("swc_trilu_image_support", "yes");
	add_option("swc_metacafe_support", "yes");
	add_option("swc_google_support", "yes");
	add_option("swc_youtube_support", "yes");
	add_option("swc_daily_support", "yes");
	add_option("swc_myspace_support", "yes");
	add_option("swc_revver_support", "yes");
	add_option("swc_spike_support", "yes");
	add_option("swc_vimeo_support", "yes");
	
	// plug-in options:
	add_option("swc_display_credit", "no");
	
	// Custom size:
	add_option("swc_flash_width", 448);
	add_option("swc_vflash_height", 386);
	add_option("swc_aflash_height", 46);
	
	// Admin usability options:
	add_option("swc_collapse_video_nice", "no");
	add_option("swc_collapse_flash_sizes", "no");
	add_option("swc_collapse_misc_options", "no");
	}
	
function swc_xhtml_video_admin_panel()
	{
	swc_add_options();
	
	if ($_SERVER['REQUEST_METHOD']=="POST")
		{
		if (isset($_POST['xve_update']))
			{
			// Update the options in a sane way ...	
			
			$option=($_POST['use_swf']=="on")?"yes":"no";
			update_option('swc_swf_support', $option);
			
			$option=($_POST['use_youtube']=="on")?"yes":"no";
			update_option('swc_youtube_support', $option);
			
			$option=($_POST['use_google']=="on")?"yes":"no";
			update_option('swc_google_support', $option);
			
			$option=($_POST['use_metacafe']=="on")?"yes":"no";
			update_option('swc_metacafe_support', $option);
			
			$option=($_POST['use_trilu_video']=="on")?"yes":"no";
			update_option('swc_trilu_video_support', $option);
			
			$option=($_POST['use_trilu_audio']=="on")?"yes":"no";
			update_option('swc_trilu_audio_support', $option);
			
			$option=($_POST['use_trilu_image']=="on")?"yes":"no";
			update_option('swc_trilu_image_support', $option);
			
			$option=($_POST['use_credit']=="on")?"yes":"no";
			update_option('swc_display_credit', $option);
						
			$option=preg_replace("@[^0-9]@", "", $_POST['uni_w']);
			if (empty($option))
				$option=448;
			update_option('swc_flash_width', $option);
			
			$option=preg_replace("@[^0-9]@", "", $_POST['uni_vh']);
			if (empty($option))
				$option=386;
			update_option('swc_vflash_height', $option);
			
			$option=preg_replace("@[^0-9]@", "", $_POST['uni_ah']);
			if (empty($option))
				$option=46;
			update_option('swc_aflash_height', $option);
			
			$option=($_POST['use_daily_video']=="on")?"yes":"no";
			update_option('swc_daily_support', $option);
			
			$option=($_POST['use_myspace_video'])?"yes":"no";
			update_option('swc_myspace_support', $option);
			
			$option=($_POST['use_revver_video'])?"yes":"no";
			update_option('swc_revver_support', $option);
			
			$option=($_POST['use_spike_video'])?"yes":"no";
			update_option('swc_spike_support', $option);
			
			$option=($_POST['use_vimeo_video'])?"yes":"no";
			update_option('swc_vimeo_support', $option);
			
			$option=($_POST['collapse_video_nice'])?"yes":"no";
			update_option('swc_collapse_video_nice', $option);

			$option=($_POST['collapse_flash_sizes'])?"yes":"no";
			update_option('swc_collapse_flash_sizes', $option);
			
			$option=($_POST['collapse_misc_options'])?"yes":"no";
			update_option('swc_collapse_misc_options', $option);
			}
		}
	echo <<<JS
	
<script type="text/javascript">
//<!--
	function showhide(targetID) {
		//change target element mode
		var elementmode = document.getElementById(targetID).style;
		elementmode.display = (!elementmode.display) ? 'none' : '';
	}
	function changetext(changee,oldText,newText) {
		//changes text in source element
		var elementToChange = document.getElementById(changee);
		elementToChange.innerHTML = (elementToChange.innerHTML == oldText) ? newText : oldText;
	}
	function workforchange(targetID,sourceID,oldContent,newContent) {
		showhide(targetID);
		changetext(sourceID,oldContent,newContent);
	}
// Cruft note: The content of "oldContent," the third argument of the
// workforchange() function, must match the existing content of the changer text.
// -->
// Show/Hide script provided by http://jopogo.com/resources/showhide.php
</script>
	
JS;

	$_centWidth="30%";
	$_checkedCollapse=get_option("swc_collapse_video_nice");
	echo '
	<div class="wrap">
	<h2>XHTML Video Embed Options</h2>
	<form method="post" action="'.$_SERVER['PHP_SELF']."?".$_SERVER['argv'][0].'">
	<table width="100%">
	<tr>
		<td colspan="3" align="right"><p class="submit"><input type="submit" name="xve_update" value="Update Options &raquo;" /></p></td>
	</tr>
	<tr>
		<td align="left" width="'.$_centWidth.'">
		<h3>';
	echo ($_checkedCollapse=="yes")?'<a href="javascript:workforchange(\'video-services\',\'changerA\',\'[+]%20Show%20Video%20services%20options\',\'[-]%20Hide%20Video%20services%20options\');" id="changerA">[+] Show Video services options</a></h3></td>':'<a href="javascript:workforchange(\'video-services\',\'changerA\',\'[-]%20Hide%20Video%20services%20options\',\'[+]%20Show%20Video%20services%20options\');" id="changerA">[-] Hide Video services options</a></h3></td>';
	echo '<td align="left"><input type="checkbox" name="collapse_video_nice" class="tog"';
	echo checked('yes', $_checkedCollapse);
	$_showStyle=($_checkedCollapse=="yes")?' style="display: none;"':'';
	echo ' /> Collapsed as default
		</td>
	</tr>
	</table>
	<table width="100%" id="video-services"'.$_showStyle.'>
	<tr>
		<td align="right" valign="top" width="20%">Use generic SWF support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_swf" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_swf_support"));
	echo ' /></td>
		<td>Usage: <strong>[swf]path-to-swf-file[/swf]</strong>
		<br />
		<a href="javascript:workforchange(\'swf\',\'changer1\',\'[+]%20Show%20SWF%20Information\',\'[-]%20Hide%20SWF%20Information\');" id=\'changer1\'>[+] Show SWF Information</a>
		<br />
		<span id="swf" style="display: none;">Note: the path can be either relative, or absolute. The absolute path is recommended if you use the pretty permalink structure when loading files which are hosted by you. By using absolute paths, you can avoid certain disfunctionalities. Of course, an absolute path is required if you use a SWF object hosted onto another domain.<br /></span><br />
		</td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use YouTube support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_youtube" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_youtube_support"));
	echo ' /></td>
		<td>Usage: <strong>[youtube]http://www.youtube.com/watch?v=5LtYk7wsFnk[/youtube]</strong>
		<br />
		<a href="javascript:workforchange(\'youtube\',\'changer2\',\'[+]%20Show%20YouTube%20Information\',\'[-]%20Hide%20YouTube%20Information\');" id=\'changer2\'>[+] Show YouTube Information</a>
		<br />
		<span id="youtube" style="display: none;">Note: The extra parameters are ignored if you use a permalink like - http://www.youtube.com/watch?v=5LtYk7wsFnk<em>&amp;feature=dir</em><br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Google Video support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_google" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_google_support"));
	echo ' /></td>
		<td>Usage: <strong>[google-video]http://video.google.com/videoplay?docid=-1770384172897733802[/google-video]</strong>
		<br />
		<a href="javascript:workforchange(\'google\',\'changer3\',\'[+]%20Show%20Google%20Video%20Information\',\'[-]%20Hide%20Google%20Video%20Information\');" id=\'changer3\'>[+] Show Google Video Information</a>
		<br />
		<span id="google" style="display: none;">Note: The extra parameters are ignored if you use a permalink like - http://video.google.com/videoplay?docid=-1770384172897733802<em>&amp;extra_parameter=extra_value</em><br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Metacafe support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_metacafe" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_metacafe_support"));
	echo ' /></td>
		<td>Usage: <strong>[metacafe]http://www.metacafe.com/watch/822298/too_much_time_to_waste/[/metacafe]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Video support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_video_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-video]http://www.trilulilu.ro/SaltwaterC/54fcf02ed330bd[/trilu-video]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Audio support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_audio" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_audio_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-audio]http://www.trilulilu.ro/ambro/26129477a2da0c[/trilu-audio]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Image support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_image" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_image_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-imagine]http://www.trilulilu.ro/SaltwaterC/336f07c30b8849[/trilu-imagine]</strong><br />
		or <strong>[trilu-image]http://www.trilulilu.ro/SaltwaterC/336f07c30b8849[/trilu-image]</strong><br />
		<a href="javascript:workforchange(\'trilu-image\',\'changer4\',\'[+]%20Show%20Trilulilu%20Image%20Information\',\'[-]%20Hide%20Trilulilu%20Image%20Information\');" id=\'changer4\'>[+] Show Trilulilu Image Information</a>
		<br />
		<span id="trilu-image" style="display: none;">Note: the [trilu-image] tag was introduced in v0.2.3 in order to match the native language (English) support of this plug-in. The [trilu-imagine] was introduced since the beginning of the development in order to preserve the full compatibility with Trilulilu\'s own WordPress plug-in. "Imagine" is the Romanian word for "Image" and it was used because Trilulilu is a Romanian video/audio/image service.<br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Dailymotion support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_daily_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_daily_support"));
	echo ' /></td>
		<td>Usage: <strong>[dailymotion]http://www.dailymotion.com/us/cluster/auto/featured/video/x4g5zc[/dailymotion]</strong><br />
		<a href="javascript:workforchange(\'daily\',\'changer5\',\'[+]%20Show%20Dailymotion%20Information\',\'[-]%20Hide%20Dailymotion%20Information\');" id=\'changer5\'>[+] Show Dailymotion Information</a>
		<br />
		<span id="daily" style="display: none;">Note: the extra parameters wrapped around the video ID are ignored. As long as the /video/{video_id}_ - from the URL is intact, the plug-in works. Use URLs from your browser\'s address bar.<br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use MySpace TV support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_myspace_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_myspace_support"));
	echo ' /></td>
		<td>Usage: <strong>[myspace]http://vids.myspace.com/index.cfm?fuseaction=vids.individual&amp;VideoID=28776245[/myspace]</strong>
		<br />
		<a href="javascript:workforchange(\'myspace\',\'changer6\',\'[+]%20Show%20MySpace%20TV%20Information\',\'[-]%20Hide%20MySpace%20TV%20Information\');" id=\'changer6\'>[+] Show MySpace TV Information</a>
		<br />
		<span id="myspace" style="display: none;">Note: MySpace TV malfunctions if you have an old Flash Player version such as v7 - it won\'t show any image. You can only hear the sound.<br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Revver support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_revver_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_revver_support"));
	echo ' /></td>
		<td>Usage: <strong>[revver]http://revver.com/video/268495/hows-my-driving/[/revver]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Spike support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_spike_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_spike_support"));
	echo ' /></td>
		<td>Usage: <strong>[spike]http://www.spike.com/video/2881456[/spike]</strong>
		<br />
		<a href="javascript:workforchange(\'spike\',\'changer7\',\'[+]%20Show%20Spike%20Information\',\'[-]%20Hide%20Spike%20Information\');" id=\'changer7\'>[+] Show Spike Information</a>
		<br />
		<span id="spike" style="display: none;">Note: when using permalinks like <em>http://www.spike.com/video/2881456?cmpnid=800&amp;lkdes=VID_2881456</em>. the parameters after the video ID are ignored.<br /></span>
		<br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Vimeo support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_vimeo_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_vimeo_support"));
	echo ' /></td>
		<td>Usage: <strong>[vimeo]http://www.vimeo.com/212286[/vimeo]</strong><br /><br /></td>
	</tr>
	</table>';
	$_checkedCollapse=get_option("swc_collapse_flash_sizes");
	echo '<table width="100%">
	<tr>
		<td align="left" width="'.$_centWidth.'">
		<h3>';
	echo ($_checkedCollapse=="yes")?'<a href="javascript:workforchange(\'flash-sizes\',\'changerC\',\'[-]%20Hide%20Flash%20size%20options\',\'[+]%20Show%20Flash%20size%20options\');" id="changerC">[+] Show Flash size options</a></h3></td>':'<a href="javascript:workforchange(\'flash-sizes\',\'changerC\',\'[-]%20Hide%20Flash%20size%20options\',\'[+]%20Show%20Flash%20size%20options\');" id="changerC">[-] Hide Flash size options</a></h3></td>';
	echo '<td align="left"><input type="checkbox" name="collapse_flash_sizes" class="tog"';
	echo checked('yes', $_checkedCollapse);
	$_showStyle=($_checkedCollapse=="yes")?' style="display: none;"':'';
	echo ' /> Collapsed as default
		</td>
	</tr>
	</table>
	<table width="100%" id="flash-sizes"'.$_showStyle.'>
	<tr>
		<td align="right" valign="top" width="20%">Unified width:</td>
		<td align="left" valign="top"><input type="text" name="uni_w" size="2" value="';
	echo get_option("swc_flash_width");
	echo '" onclick="this.focus(); this.select();" /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Unified video/image height:</td>
		<td align="left" valign="top"><input type="text" name="uni_vh" size="2" value="';
	echo get_option("swc_vflash_height");
	echo '" onclick="this.focus(); this.select();" /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Unified audio height:</td>
		<td align="left" valign="top"><input type="text" name="uni_ah" size="2" value="';
	echo get_option("swc_aflash_height");
	echo '" onclick="this.focus(); this.select();" /></td>
	</tr>
	</table>';
	$_checkedCollapse=get_option("swc_collapse_misc_options");
	echo'<table width="100%">
	<tr>
		<td align="left" width="'.$_centWidth.'">
		<h3>';
	echo ($_checkedCollapse=="yes")?'<a href="javascript:workforchange(\'misc-options\',\'changerD\',\'[-]%20Hide%20Miscellaneous%20options\',\'[+]%20Show%20Miscellaneous%20options\');" id="changerD">[+] Show Miscellaneous options</a></h3></td>':'<a href="javascript:workforchange(\'misc-options\',\'changerD\',\'[-]%20Hide%20Miscellaneous%20options\',\'[+]%20Show%20Miscellaneous%20options\');" id="changerD">[-] Hide Miscellaneous options</a></h3></td>';
	echo '<td align="left"><input type="checkbox" name="collapse_misc_options" class="tog"';
	echo checked('yes', $_checkedCollapse);
	$_showStyle=($_checkedCollapse=="yes")?' style="display: none;"':'';
	echo ' /> Collapsed as default
		</td>
	</tr>
	</table>
	<table width="100%" id="misc-options"'.$_showStyle.'>
	<tr>
		<td align="right" valign="top" width="20%">Use credit for XVE?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_credit" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_display_credit"));
	echo ' /></td>
		<td>Note: this places a small URL under the inserted flash object with <a href="http://saltwaterc.net/xhtml-video-embed" target="_blank">&raquo; Powered by XHTML Video Embed</a>. You don\'t have to use it, so that\'s why it\'s disabled by default. If you would like to support the spreading of this plug-in (and me as developer), then please check this option. Otherwize, the plug-in displays it in silent mode (as XHTML comment). If you mind using this, then remove it from the source code.<br /><br /></td>
	</tr>
	</table>
	<table width="100%">
	<tr>
		<td colspan="3" align="right"><p class="submit"><input type="submit" name="xve_update" value="Update Options &raquo;" /></p></td>
	</tr>
	</table>
	</form>
	<p>Plug-in developed by <a href="http://saltwaterc.net/" title="Open my eyes, saltwater rain ..." target="_blank">SaltwaterC</a> under the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html" title="GNU General Public License, version 2" target="_blank">GPL v2.0</a> license.</p>
	</div>';
	}

// Adding the hooks:
add_filter('the_content', 'swc_xhtml_video_embed');
add_action('admin_menu', 'swc_xhtml_video_admin');
?>
